'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _nodeType = require('./nodeType');

var _nodeType2 = _interopRequireDefault(_nodeType);

var _path = require('./path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Context = function () {
  function Context(opts, state) {
    _classCallCheck(this, Context);

    this.opts = opts;
    this.state = state;
  }

  _createClass(Context, [{
    key: 'visit',
    value: function visit(node, key) {
      var nodes = node[key];
      if (Array.isArray(nodes)) {
        this.visitArray(nodes, node, key);
      } else if ((typeof nodes === 'undefined' ? 'undefined' : _typeof(nodes)) === 'object') {
        this.visitProperties(nodes, node, key);
      } else if (nodes) {
        this.visitSingle(node, key);
      }
    }
  }, {
    key: 'shouldVisit',
    value: function shouldVisit(node) {
      var opts = this.opts;
      if (opts.enter || opts.exit) {
        return true;
      }
      if (opts[(0, _nodeType2.default)(node)]) {
        return true;
      }
      return false;
    }
  }, {
    key: 'visitSingle',
    value: function visitSingle(parent, key) {
      var node = parent[key];
      if (!this.shouldVisit(node)) return;
      var path = new _path2.default({
        opts: this.opts,
        parent: parent,
        container: parent,
        node: node,
        key: key
      });
      path.visit();
    }
  }, {
    key: 'visitArray',
    value: function visitArray(container, parent, listKey) {
      var _this = this;

      container.forEach(function (node, key) {
        if (!_this.shouldVisit(node)) return;
        var path = new _path2.default({
          opts: _this.opts,
          parent: parent,
          container: container,
          node: node,
          key: key,
          listKey: listKey
        });
        path.visit();
      });
    }
  }, {
    key: 'visitProperties',
    value: function visitProperties(container, parent, listKey) {
      var _this2 = this;

      Object.keys(container).forEach(function (key) {
        var node = container[key];
        if (!_this2.shouldVisit(node)) return;
        var path = new _path2.default({
          opts: _this2.opts,
          parent: parent,
          container: container,
          node: node,
          key: key,
          listKey: listKey
        });
        path.visit();
      });
    }
  }]);

  return Context;
}();

exports.default = Context;