'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

exports.default = explode;
/**
 * { object () {} }
 * => { object: { enter: function () {} }
 *
 * { 'object|string' () {} }
 * => {
 *      object: { enter: function () {} },
 *      string: { enter: function () {} }
 *    }
 */
function explode(opts) {
  opts = Object.assign({}, opts);
  opts = correctOpt(opts);

  Object.keys(opts).filter(function (key) {
    return !/^(enter|exit)$/.test(key);
  }).forEach(function (key) {
    var value = correctOpt(opts[key]);
    // "object|string": { ... }
    if (/\w\|\w/.test(key)) {
      key.split('|').forEach(function (key) {
        return opts[key] = value;
      });
      delete opts[key];
    } else {
      opts[key] = value;
    }
  });

  return opts;
};

/**
 * function () {} => { enter: function () {} }
 * { enter: 'not function' } => false
 */
function correctOpt(opt) {
  if (typeof opt === 'function') {
    return { enter: opt };
  } else if ((typeof opt === 'undefined' ? 'undefined' : _typeof(opt)) !== 'object') {
    return {};
  }

  if (typeof opt.enter !== 'function') delete opt.enter;
  if (typeof opt.exit !== 'function') delete opt.exit;
  return opt;
}