'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _traverseNode = require('./traverseNode');

var _traverseNode2 = _interopRequireDefault(_traverseNode);

var _nodeType = require('./nodeType');

var _nodeType2 = _interopRequireDefault(_nodeType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var isFunction = function isFunction(value) {
  return typeof value === 'function';
};

var NodePath = function () {
  function NodePath(_ref) {
    var parentPath = _ref.parentPath;
    var parent = _ref.parent;
    var container = _ref.container;
    var node = _ref.node;
    var key = _ref.key;
    var listKey = _ref.listKey;
    var opts = _ref.opts;
    var state = _ref.state;

    _classCallCheck(this, NodePath);

    this.parentPath = parentPath;
    this.parent = parent;
    this.container = container;
    this.node = node;
    this.key = key;
    this.listKey = listKey;
    this.nodeType = (0, _nodeType2.default)(node);
    this.opts = opts;
    this.state = state;
  }

  _createClass(NodePath, [{
    key: 'visit',
    value: function visit() {
      this.call('enter');
      (0, _traverseNode2.default)(this.node, this.opts, this.state, this);
      this.call('exit');
    }
  }, {
    key: 'call',
    value: function call(key) {
      if (isFunction(this.opts[key])) {
        this.opts[key].call(this.state, this, this.state);
      }
      var type = this.nodeType;
      if (this.opts[type] && isFunction(this.opts[type][key])) {
        this.opts[type][key].call(this.state, this, this.state);
      }
    }
  }]);

  return NodePath;
}();

exports.default = NodePath;